CONTENTS OF THIS FILE
---------------------

* About
* Requirements
* Installation
* Use / Commands
* Configuration
* Maintainers

ABOUT
-----

The files and directories of this theme are meant to use components as the base
philosophy for building websites.

All the build tools are set up in a way so that developers working on this project
are utilizing the same global assets and versions, file compilation is easy to get
started with and compilation itself is fast and efficient.

REQUIREMENTS
------------

This theme and it's build tools require the following local development tools:

* [Node.js](https://nodejs.org/en/)
* [NPM](https://docs.npmjs.com/downloading-and-installing-node-js-and-npm)
* [NVM](https://github.com/nvm-sh/nvm/blob/master/README.md)

INSTALLATION
------------

1. Before installing any node modules, first be sure you are using the
defined version of Node for this project. The following command requires the 
tool NVM Node package manager. If you do not have the recommended version of Node
installed on your computer, NVM will prompt you to download and install the 
correct version -- `nvm use`
2. Once you are using the recommended version of Node, you may install all Node
modules defined in the package.json file -- `npm install`
3. To correctly utilize Browsersync, copy the `.env-example` file and rename it `.env`. Within this file
specify both your local website address and default browser.

USE / COMMANDS
--------------

**Local Development**

In order to watch file changes and compile files during local development, input
the following command and allow both Gulp and Webpack to watch for changes and/or
additions to the libraries directory. -- `npm run watch`

**Production**

When local development is finished and ready to be pushed to a remote environment,
build and minify all files, readying all assets for production. In order to minify
and optimize all files and assets, run the following command. -- `npm run build`

CONFIGURATION
-------------

**Browser Support:** This theme uses PostCSS and Babel to provide cross-browser support for newer CSS
and JS features. Both of these tools rely upon the following files for configuration and settings.

- `postcss.config.js` - This file contains all settings, overrides and extra plugins for the PostCSS
module, including PostCSS Preset Env and PostCSS Inline SVG, as detailed below.
- `babel.config.js` - This file contains all settings, overrides and extra plugins for the Babel
module, as well as settings for caching JavaScript in Babel.
- `.browserslistrc` - This file contains instructions to other modules like Babel and PostCSS on what
browsers to support when transpiling frontend assets. Currently, Prototype is supporting the last 4
versions (`last 4 versions`) of any browser that more than 0.5% of the population is using (`> .5%`)
and am also disregarding Internet Explorer (`not IE 10`, `not IE_mob 10`).

**PostCSS Inline SVG**  
Prototype now offers an easy way to inject inline SVG's into your CSS. In order to take advantage of
the PostCSS Inline SVG plugin, simple utilize the predefined function from this plugin, with path to
the SVG and any inline styles that you need to add.

Example: `background: svg-load('image.svg', fill=#000000);`

**Resources**
- [PostCSS](https://github.com/postcss/postcss)
- [PostCSS Preset Env](https://github.com/csstools/postcss-plugins/tree/main/plugin-packs/postcss-preset-env)
- [PostCSS Inline SVG](https://github.com/TrySound/postcss-inline-svg)
- [Babel](https://babeljs.io/)


MAINTAINERS
-----------

* Philip Stier - philip@aten.io
* Jennifer Dust - jennifer@aten.io
* Bryon Urbanec - bryon@aten.io
* John Ferris - john@aten.io